//America.cs
datablock AudioProfile(AmericaDrawSound)
{
   filename    = "./AmericaDraw.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(AmericaHitSound)
{
   filename    = "./AmericaHit.wav";
   description = AudioClosest3d;
   preload = true;
};


//effects
datablock ParticleData(AmericaExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = -2.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -100;
   spinRandomMax = -100;
   lifetimeMS           = 1900;
   lifetimeVarianceMS   = 1000;
   textureName          = "./Americachunk";
   colors[0]     = "0.6 0.6 0.6 0.9";
   colors[1]     = "0.6 0.6 0.6 0.9";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
};

datablock ParticleEmitterData(AmericaExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "AmericaExplosionParticle";

   uiName = "America Hit";
};

datablock ExplosionData(AmericaExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = AmericaHitSound;

   particleEmitter = AmericaExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "2.0 0.2 0.6";
   lightEndColor = "0 0 0";
};


//projectile
AddDamageType("America",   '<bitmap:add-ons/Weapon_America/CI_America> %1',    '%2 <bitmap:add-ons/Weapon_America/CI_America> %1',0.75,1);
datablock ProjectileData(AmericaProjectile)
{
   directDamage        = 20;
   directDamageType  = $DamageType::America;
   radiusDamageType  = $DamageType::America;
   explosion           = AmericaExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 250;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 2;
   bounceFriction      = 2;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 0.5;
   lightColor  = "0.5 0 0";

   uiName = "America Slice";
};


//////////
// item //
//////////
datablock ItemData(AmericaItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./America.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "America";
	iconName = "./icon_America";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = AmericaImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(AmericaImage)
{
   // Basic Item properties
   shapeFile = "./America.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = AmericaItem;
   ammo = " ";
   projectile = AmericaProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = AmericaDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function AmericaImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function AmericaImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}